ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.16 by root, Wed Mar 14 15:47:21 2007 UTC vs.
Revision 1.72 by root, Mon Oct 12 14:01:00 2009 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::EV;
17use AnyEvent; 18use AnyEvent;
19use YAML::XS ();
20use JSON::XS ();
18use IO::AIO (); 21use IO::AIO ();
19use File::Temp; 22use File::Temp;
20use Crossfire; 23use Deliantra;
21use Coro; 24use Coro 5.12;
22use Coro::AIO; 25use Coro::AIO;
26use Coro::Util;
23use POSIX (); 27use POSIX ();
24use Digest::MD5; 28use Carp;
29use Coro::Channel;
30use Coro::Storable; $Storable::canonical = 1;
31
32$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 33
26sub usage { 34sub usage {
27 warn <<EOF; 35 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 36Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 37 [--install-arch path]
41my $CACHE = 0; 49my $CACHE = 0;
42my $FORCE; 50my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 51my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 52my $TMPFILE = "aaaa0";
45 53
54our %COLOR = (
55 black => 0,
56 white => 1,
57 navy => 2,
58 red => 3,
59 orange => 4,
60 blue => 5,
61 darkorange => 6,
62 green => 7,
63 lightgreen => 8,
64 grey => 9,
65 brown => 10,
66 gold => 11,
67 tan => 12,
68);
69
46END { system "rm", "-rf", $TMPDIR } 70END { system "rm", "-rf", $TMPDIR }
47 71
48Event->signal (signal => "INT", cb => sub { exit 1 }); 72my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 73my $s_TERM = EV::signal TERM => sub { exit 1 };
50 74
51mkdir $TMPDIR, 0700 75mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 76 or die "$TMPDIR: $!";
53 77
54sub fork_sub(&) { 78sub fork_sub(&) {
67} 91}
68 92
69sub inst_maps($) { 93sub inst_maps($) {
70 my (undef, $path) = @_; 94 my (undef, $path) = @_;
71 95
72 print "installing '$path' to '$DATADIR/maps'\n"; 96 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 97
74 if (!-f "$path/regions") { 98 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 99 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 100 exit 1 unless $FORCE;
77 } 101 }
78 102
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 103 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
104 "$path/.", "$DATADIR/maps/.",
105 "--exclude", "CVS", "--exclude", "/world-precomposed",
106 "--delete", "--delete-excluded"
80 and die "map installation failed.\n"; 107 and die "map installation failed.\n";
81 108
82 print "maps installed successfully.\n"; 109 print "maps installed successfully.\n";
83} 110}
84 111
85{ 112{
86 our %PNG32; 113 our %ANIMINFO;
87 our %FACEINFO; 114 our %FACEINFO;
115 our %RESOURCE;
88 our @ARC; 116 our @ARC;
117 our %ARC;
89 our $TRS; 118 our $TRS;
90 our $NFILE; 119 our $NFILE;
91 our %ANIM; 120 our $PATH;
92 121
93 our (@png, @trs, @arc); # files we are interested in 122 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
94 123
124 our $c_arc = new Coro::Channel;
125 our $c_trs = new Coro::Channel;
126 our $c_res = new Coro::Channel;
127
128 our @c_png;
129
95 sub commit_png { 130 sub commit_png($$$) {
96 my ($name, $data) = @_; 131 my ($name, $data, $T) = @_;
97 132
98 $PNG32{$name} = $data; 133 $FACEINFO{$name}{"data$T"} = $data;
99 $FACEINFO{$name} ||= {};
100 } 134 }
101 135
102 sub process_png { 136 sub process_png {
103 while (@png) { 137 while (@c_png) {
104 my $path = pop @png; 138 my ($path, $delete) = @{pop @c_png};
105 139
106 my $png; 140 my $png;
107 aio_lstat $path; 141 aio_lstat $path;
108 my ($size, $mtime) = (stat _)[7,9]; 142 my ($size, $mtime) = (stat _)[7,9];
109 143
110 if (0 > aio_load $path, $png) { 144 if (0 > aio_load $path, $png) {
111 warn "$path: $!, skipping.\n"; 145 warn "$path: $!, skipping.\n";
112 next; 146 next;
113 } 147 }
114 148
149 my $stem = $path;
150 my $T;
151
152 if ($stem =~ s/\.32x32\.png~?$//) {
153 $T = 32;
154 } elsif ($stem =~ s/\.64x64\.png~?$//) {
155 $T = 64;
156 } else {
157 warn "$path: weird filename, skipping.\n";
158 next;
159 }
160
115 # quickly extract width and height of the (necessarily PNG) image 161 # quickly extract width and height of the (necessarily PNG) image
116 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 162 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
117 warn "$path: not a recongized png file, skipping.\n"; 163 warn "$path: not a recognized png file, skipping.\n";
118 next; 164 next;
119 } 165 }
120 166
121 my ($w, $h) = unpack "NN", $1; 167 my ($w, $h) = unpack "NN", $1;
122
123 (my $face = $path) =~ s/^.*\///;
124 my $T = 32;
125
126 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
127 warn "$path: weird filename, skipping.\n";
128 next;
129 }
130 168
131 if ($w < $T || $h < $T) { 169 if ($w < $T || $h < $T) {
132 warn "$path: too small ($w $h), skipping.\n"; 170 warn "$path: too small ($w $h), skipping.\n";
133 next; 171 next;
134 } 172 }
136 if ($w % $T || $h % $T) { 174 if ($w % $T || $h % $T) {
137 warn "$path: weird png size ($w $h), skipping.\n"; 175 warn "$path: weird png size ($w $h), skipping.\n";
138 next; 176 next;
139 } 177 }
140 178
179 (my $base = $stem) =~ s/^.*\///;
180
181 my $fi = $FACEINFO{$base};
182 unless ($fi) {
183 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
184 #next;
185 }
186
187 my $arc = $fi->{arc} || { };
188
189 unless ($path =~ /~$/) {
190 # possibly enlarge
191 if (0 > aio_stat "$stem.64x64.png") {
192 my $other = "$stem.64x64.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 my $CROP;
197 my $SRC = "png:\Q$path\E";
198
199 my $is_floor = $arc->{is_floor};
200 my $is_wall = 0;
201
202 my ($wall_pfx, $wall_dir, $wall_sfx);
203
204 if (
205 !$is_floor
206 && !$arc->{alive}
207 && $arc->{move_block} eq "all"
208 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
209 ) {
210 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
211
212 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
213 $is_wall = 1;
214 }
215 }
216
217 if ($is_wall || $is_floor) {
218 # add a 4px border and add other images around it
219 $CROP = "-shave 8x8 +repage";
220
221 $w += 8;
222 $h += 8;
223
224 $SRC = "-size ${w}x${h} xc:transparent";
225 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
226
227 # 8 surrounding images
228 for (
229 # x y b r0 r1
230 [-1, -1, 0, 6],
231 [ 0, -1, 1, 10, 14],
232 [+1, -1, 0, 12],
233
234 [-1, 0, 8, 5, 7],
235 #
236 [+1, 0, 2, 5, 13],
237
238 [-1, +1, 0, 3],
239 [ 0, +1, 4, 10, 11],
240 [+1, +1, 0, 9],
241 ) {
242 my ($x, $y, $d, $r0, $r1) = @$_;
243
244 my $tile = $is_floor ? $path
245 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
246 : die;
247
248 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
249 "\Q$tile",
250 $x * ($w - 8) + 4,
251 $y * ($h - 8) + 4;
252 }
253 }
254
255 system "convert -depth 8 $SRC rgba:-"
256 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
257 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
258 and die "convert/cfhq2xa pipeline error: status $? ($!)";
259 system $OPTIPNG, "-i0", "-q", "$other~";
260 die "$other~ has zero size, aborting." unless -s "$other~";
261 rename "$other~", $other;
262 };
263 }
264
265 push @c_png, [$other, !$CACHE];
266 }
267
268 # possibly scale down
269 if (0 > aio_stat "$stem.32x32.png") {
270 my $other = "$stem.32x32.png~";
271
272 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
273 fork_sub {
274 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
275 system $OPTIPNG, "-i0", "-q", "$other~";
276
277 # reduce smoothfaces >10000 bytes
278 # obsolete, no longer required
279 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
280 my $ncolor = 256;
281 while () {
282 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
283 system $OPTIPNG, "-i0", "-q", "$other~~";
284 last if 10000 > -s "$other~~";
285 $ncolor = int $ncolor * 0.9;
286 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
287 }
288
289 printf "reduced %s from %d to %d bytes using %d colours.\n",
290 $other, -s "$other~", -s "$other~~", $ncolor
291 if $VERBOSE >= 2;
292 rename "$other~~", "$other~";
293 }
294
295 die "$other~ has zero size, aborting." unless -s "$other~";
296 rename "$other~", $other;
297 };
298 }
299
300 #warn "scaled down $path to $other\n";#d#
301 push @c_png, [$other, !$CACHE];
302 }
303 }
304
305 (my $face = $stem) =~ s/^.*\///;
306
307 # split all bigfaces, but avoid smoothfaces (*_S)
141 if (($w > $T || $h > $T) && $face !~ /_S\./) { 308 if (($w > $T || $h > $T) && $face !~ /_S\./) {
142 # split 309 # split
143 my @tile; 310 my @tile;
144 for my $x (0 .. (int $w / $T) - 1) { 311 for my $x (0 .. (int $w / $T) - 1) {
145 for my $y (0 .. (int $h / $T) - 1) { 312 for my $y (0 .. (int $h / $T) - 1) {
159 ( 326 (
160 "(", 327 "(",
161 "+clone", 328 "+clone",
162 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 329 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
163 "+repage", 330 "+repage",
331 -quality => "00",
164 -write => "png:$_->[2]~", 332 -write => "png32:$_->[2]~",
165 "+delete", 333 "+delete",
166 ")", 334 ")",
167 ) 335 )
168 } @todo), 336 } @todo),
169 "null:"; 337 "null:";
173 close $convert; 341 close $convert;
174 342
175 # pass 2, optimise, and rename 343 # pass 2, optimise, and rename
176 for (@todo) { 344 for (@todo) {
177 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 345 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
346 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
178 rename "$_->[2]~", $_->[2]; 347 rename "$_->[2]~", $_->[2];
179 } 348 }
180 }; 349 };
181 } 350 }
182 351
186 355
187 if (0 > aio_load $file, $tile) { 356 if (0 > aio_load $file, $tile) {
188 die "$path: unable to read tile +$x+$y, aborting.\n"; 357 die "$path: unable to read tile +$x+$y, aborting.\n";
189 } 358 }
190 IO::AIO::aio_unlink $file unless $CACHE; 359 IO::AIO::aio_unlink $file unless $CACHE;
191 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 360 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
192 } 361 }
193 } else { 362 } else {
194 # use as-is (either small, use smooth) 363 # use as-is (either small, use smooth)
195 commit_png $face, $png; 364 commit_png $face, $png, $T;
196 } 365 }
366
367 aio_unlink $path if $delete;
197 } 368 }
198 } 369 }
199 370
200 sub process_arc { 371 sub process_arc {
201 while (@arc) { 372 while (my $job = $c_arc->get) {
202 my ($dir, $file) = @{pop @arc}; 373 my ($dir, $file) = @$job;
203 374
204 my $arc; 375 my $arc;
205 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 376 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
206 377
207 my $arc = read_arch "$dir/$file"; 378 my $arc = read_arch "$dir/$file";
208 for my $o (values %$arc) { 379 for my $o (values %$arc) {
209 push @ARC, $o; 380 push @ARC, $o;
381 for (my $m = $o; $m; $m = $m->{more}) {
382 $ARC{$m->{_name}} = $m;
383 }
210 384
211 $o->{editor_folder} = $dir; 385 $o->{editor_folder} = $dir;
212 386
213 my $visibility = delete $o->{visibility}; 387 my $visibility = delete $o->{visibility};
214 my $magicmap = delete $o->{magicmap}; 388 my $magicmap = delete $o->{magicmap};
225 my $x = $o->{x} - $dx; 399 my $x = $o->{x} - $dx;
226 my $y = $o->{y} - $dy; 400 my $y = $o->{y} - $dy;
227 401
228 my $ext = $x|$y ? "+$x+$y" : ""; 402 my $ext = $x|$y ? "+$x+$y" : "";
229 403
230 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 404 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
231 405
232 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 406 $visibility = delete $o->{visibility} if exists $o->{visibility};
233 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 407 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
234 408
235 my $anim = delete $o->{anim}; 409 my $anim = delete $o->{anim};
236 410
237 if ($anim) { 411 if ($anim) {
412 # possibly add $ext to the animation name to avoid
413 # the need to specify archnames for all parts
414 # of a multipart archetype.
238 $o->{animation} = "$o->{_name}"; 415 $o->{animation} = "$o->{_name}";
416 my $facings = 1;
417 my @frames;
239 418
240 for (@$anim) { 419 for (@$anim) {
241 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 420 if (/^facings\s+(\d+)/) {
421 $facings = $1*1;
422 } elsif (/^blank.x11$|^empty.x11$/) {
423 push @frames, $_;
424 } else {
425 push @frames, "$_$ext";
426 }
242 } 427 }
243 428
244 $ANIM{"$o->{_name}$ext"} = 429 $ANIMINFO{$o->{animation}} = {
245 join "", map "$_\n", 430 facings => $facings,
246 "anim $o->{_name}", 431 frames => \@frames,
247 @$anim,
248 "mina";
249 } 432 };
433 }
250 434
251 for my $face ($o->{face} || (), @{$anim || []}) { 435 for ($o->{face} || (), @{$anim || []}) {
252 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 436 next if /^facings\s/;
253 437
438 my $face = $_;
439 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
440
254 my $info = $FACEINFO{$face} ||= {}; 441 my $info = $FACEINFO{$face} ||= { };
442 $info->{arc} = $o;
443
444 next if $face =~ /^blank.x11$|^empty.x11$/;
255 445
256 $info->{visibility} = $visibility if defined $visibility; 446 $info->{visibility} = $visibility if defined $visibility;
257 $info->{magicmap} = $magicmap if defined $magicmap; 447 $info->{magicmap} = $magicmap if defined $magicmap;
258 } 448 }
259 449
260 if (my $smooth = delete $o->{smoothface}) { 450 if (my $smooth = delete $o->{smoothface}) {
261 my ($face, $smooth) = split /\s+/, $smooth; 451 my %kv = split /\s+/, $smooth;
262 # skip empty_S.x11, it seems to server no purpose whatsoever 452 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
263 # but increases bandwidth demands and worse. 453 while (my ($face, $smooth) = each %kv) {
264 unless ($smooth eq "empty_S.x11") { 454 $FACEINFO{$smooth}{arc} = $o;
455
265 $FACEINFO{$face}{smooth} = $smooth; 456 $FACEINFO{$face}{smooth} = $smooth;
457 $FACEINFO{$face}{smoothlevel} = $level;
266 } 458 }
267 } 459 }
268 } 460 }
269 } 461 }
270 } 462 }
271 } 463 }
272 464
273 sub process_trs { 465 sub process_trs {
274 while (@trs) { 466 while (my $job = $c_trs->get) {
275 my ($dir, $file) = @{pop @trs}; 467 my ($dir, $file) = @$job;
276 my $path = "$dir/$file"; 468 my $path = "$dir/$file";
277 469
278 my $trs; 470 my $trs;
279 if (0 > aio_load $path, $trs) { 471 if (0 > aio_load $path, $trs) {
280 warn "$path: $!, skipping.\n"; 472 warn "$path: $!, skipping.\n";
283 475
284 $TRS .= $trs; 476 $TRS .= $trs;
285 } 477 }
286 } 478 }
287 479
480 my %FILECACHE;
481
482 sub load_cached($;$) {
483 unless (exists $FILECACHE{$_[0]}) {
484 my $data;
485 if (0 < aio_load $_[0], $data) {
486 if ($_[1]) {
487 $data = eval { $_[1]->($data) };
488 warn "$_[0]: $@" if $@;
489 }
490 }
491
492 $FILECACHE{$_[0]} = $data;
493 }
494
495 $FILECACHE{$_[0]}
496 }
497
498 sub process_res {
499 while (my $job = $c_res->get) {
500 my ($dir, $file, $type) = @$job;
501
502 my $data;
503 aio_load "$dir/$file", $data;
504
505 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
506
507 utf8::decode $dir;
508 utf8::decode $file;
509
510 # a meta file for resources is now mandatory
511 unless (exists $meta->{$file}) {
512 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
513 next;
514 }
515
516 $meta = {
517 %{ $meta->{"" } || {} },
518 %{ $meta->{$file} || {} },
519 };
520
521 if ($meta->{license} =~ s/^#//) {
522 $meta->{license} = ({
523 "pd" => "Public Domain",
524 "gpl" => "GNU General Public License, version 3.0 or any later",
525 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
526 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
527 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
528 })->{$meta->{license}}
529 || warn "$dir/$file: license tag '$meta->{license}' not found.";
530 }
531
532 $file =~ s/\.res$//;
533 $file =~ s/\.(ogg|wav|jpg|png)$//;
534
535 substr $dir, 0, 1 + length $PATH, "";
536
537 if (my $filter = $meta->{cfutil_filter}) {
538 if ($filter eq "yaml2json") {
539 $data = JSON::XS::encode_json YAML::XS::Load $data;
540 } elsif ($filter eq "json2json") {
541 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
542 } elsif ($filter eq "perl2json") {
543 $data = eval $data; die if $@;
544 $data = JSON::XS::encode_json $data;
545 } else {
546 warn "$dir/$file: unknown filter $filter, skipping\n";
547 }
548 }
549
550 $RESOURCE{"$dir/$file"} = {
551 type => (exists $meta->{type} ? delete $meta->{type} : $type),
552 data => $data,
553 %$meta ? (meta => $meta) : (),
554 };
555 }
556 }
557
288 sub find_files; 558 sub find_files;
289 sub find_files { 559 sub find_files {
290 my ($path) = @_; 560 my ($path) = @_;
291 561
292 IO::AIO::aioreq_pri 4; 562 IO::AIO::aioreq_pri 4;
294 my ($dirs, $nondirs) = @_; 564 my ($dirs, $nondirs) = @_;
295 565
296 find_files "$path/$_" 566 find_files "$path/$_"
297 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 567 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
298 568
569 my $dir = $path;
570 substr $dir, 0, 1 + length $PATH, "";
571
299 for my $file (@$nondirs) { 572 for my $file (@$nondirs) {
573 if ($dir =~ /^music(?:\/|$)/) {
574 $c_res->put ([$path, $file, 3]) # FT_MUSIC
575 if $file =~ /\.(ogg)$/;
576
577 } elsif ($dir =~ /^sound(?:\/|$)/) {
578 $c_res->put ([$path, $file, 5]) # FT_SOUND
579 if $file =~ /\.(wav|ogg)$/;
580
581 } elsif ($dir =~ /^res(?:\/|$)/) {
582 if ($file =~ /\.(jpg|png)$/) {
583 $c_res->put ([$path, $file, 0]) # FT_FACE
584 } elsif ($file =~ /\.(res)$/) {
585 $c_res->put ([$path, $file, 6]) # FT_RSRC
586 } else {
587 $c_res->put ([$path, $file, undef]);
588 }
589
300 if ($file =~ /\.png$/) { 590 } elsif ($file =~ /\.png$/) {
301 push @png, "$path/$file"; 591 push @c_png, ["$path/$file", 0];
592
302 } elsif ($file =~ /\.trs$/) { 593 } elsif ($file =~ /\.trs$/) {
303 push @trs, [$path, $file]; 594 $c_trs->put ([$path, $file]);
595
304 } elsif ($file =~ /\.arc$/) { 596 } elsif ($file =~ /\.arc$/) {
305 push @arc, [$path, $file]; 597 $c_arc->put ([$path, $file]);
598
306 } else { 599 } else {
307 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 600 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
308 } 601 }
309 } 602 }
310 }; 603 };
311 } 604 }
312 605
313 sub inst_arch($) { 606 sub inst_arch($) {
314 my (undef, $path) = @_; 607 my (undef, $path) = @_;
315 608
609 $PATH = $path;
610
611 print "\n",
316 print "installing '$path' to '$DATADIR'\n"; 612 "Installing '$path' to '$DATADIR'\n",
613 "\n",
614 "This can take a long time if you run this\n",
615 "for the first time or do not use --cache.\n",
616 "\n",
617 "Unless you run verbosely, all following warning\n",
618 "or error messages indicate serious problems.\n",
619 "\n";
317 620
318 if (!-d "$path/treasures") { 621 if (!-d "$path/treasures") {
319 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 622 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
320 exit 1 unless $FORCE; 623 exit 1 unless $FORCE;
321 } 624 }
322 625
626 print "scanning files...\n" if $VERBOSE;
627
323 find_files $path; 628 find_files $path;
629
630 my @a_arc = map +(async \&process_arc), 1..2;
631 my @a_res = map +(async \&process_res), 1..2;
632 my @a_trs = map +(async \&process_trs), 1..2;
633
324 IO::AIO::flush; 634 IO::AIO::flush;
325 635
326 $_->join for ( 636 $c_res->shutdown;
327 (async \&process_png), (async \&process_png), 637 $c_arc->shutdown;
328 (async \&process_trs), (async \&process_trs), 638 $c_trs->shutdown;
329 (async \&process_arc), (async \&process_arc),
330 );
331 639
640 print "start file scan, arc, res processing...\n" if $VERBOSE;
641
642 $_->join for @a_arc; # need to parse all archetypes before png processing
643
644 print "end arc, start png processing...\n" if $VERBOSE;
645
646 # eight png crunchers work fine for my 4x smp machine
647 my @a_png = map +(async \&process_png), 1..8;
648
649 $_->join for (@a_trs, @a_res, @a_png);
650
651 print "scanning done, processing results...\n" if $VERBOSE;
332 { 652 {
333 open my $fh, ">:utf8", "$DATADIR/animations~" 653 # remove path prefix from editor_folder
334 or die "$DATADIR/animations~: $!"; 654 substr $_->{editor_folder}, 0, 1 + length $path, ""
335 print $fh join "", map $ANIM{$_}, sort keys %ANIM 655 for values %ARC;
656
657 print "resolving inheritance tree...\n" if $VERBOSE;
658 # resolve inherit
659 while () {
660 my $progress;
661 my $loop;
662
663 for my $o (values %ARC) {
664 if (my $other = $o->{inherit}) {
665 if (my $s = $ARC{$other}) {
666 if ($s->{inherit}) {
667 $loop = $s;
668 } else {
669 delete $o->{inherit};
670 my %s = %$s;
671 delete @s{qw(_name more name name_pl)};
672 %$o = ( %s, %$o );
673 ++$progress;
674 }
675 } else {
676 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
677 delete $ARC{$o->{_name}};
678 }
679 }
680 }
681
682 unless ($progress) {
683 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
684 if $loop;
685
686 last;
687 }
336 } 688 }
337 689
338 { 690 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
691 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
692
693 print "writing archetypes...\n" if $VERBOSE;
339 open my $fh, ">:utf8", "$DATADIR/archetypes~" 694 open my $fh, ">:utf8", "$DATADIR/archetypes~"
340 or die "$DATADIR/archetypes~: $!"; 695 or die "$DATADIR/archetypes~: $!";
341 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 696 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
342 print $fh Crossfire::archlist_to_string \@ARC;
343 } 697 }
344 698
345 { 699 {
700 print "writing treasures...\n" if $VERBOSE;
346 open my $fh, ">:utf8", "$DATADIR/treasures~" 701 open my $fh, ">:utf8", "$DATADIR/treasures~"
347 or die "$DATADIR/treasures~: $!"; 702 or die "$DATADIR/treasures~: $!";
348 print $fh $TRS; 703 print $fh $TRS;
349 } 704 }
350 705
351 { 706 {
352 while (my ($k, $v) = each %FACEINFO) { 707 print "processing facedata...\n" if $VERBOSE;
353 $v->{data32} ||= delete $PNG32{$k};
354 }
355
356 while (my ($k, $v) = each %FACEINFO) { 708 while (my ($k, $v) = each %FACEINFO) {
357 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 709 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
710 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
358 711
359 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 712 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
713 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
714
715 if (my $magicmap = $v->{magicmap}) {
716 $magicmap =~ y/A-Z_\-/a-z/d;
717 $v->{magicmap} = $COLOR{$magicmap};
360 } 718 }
361 719
720 delete $v->{arc};
721 }
722
723 print "writing facedata...\n" if $VERBOSE;
362 open my $fh, ">:perlio", "$DATADIR/faces~" 724 open my $fh, ">:perlio", "$DATADIR/facedata~"
363 or die "$DATADIR/faces~: $!"; 725 or die "$DATADIR/facedata~: $!";
364 726
365 $FACEINFO{""} = { version => 1}; 727 print $fh freeze {
366 print $fh Storable::nfreeze \%FACEINFO; 728 version => 2,
729 faceinfo => \%FACEINFO,
730 animinfo => \%ANIMINFO,
731 resource => \%RESOURCE,
367 } 732 };
733 }
368 734
735 print "committing files...\n" if $VERBOSE;
736
369 for (qw(archetypes faces animations treasures)) { 737 for (qw(archetypes facedata treasures)) {
370 chmod 0644, "$DATADIR/$_~"; 738 chmod 0644, "$DATADIR/$_~";
371 rename "$DATADIR/$_~", "$DATADIR/$_" 739 rename "$DATADIR/$_~", "$DATADIR/$_"
372 or die "$DATADIR/$_: $!"; 740 or die "$DATADIR/$_: $!";
373 } 741 }
374 742

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines